//==============================================================================
//                                                          
// This software artifact was generated using PlasmaSDO    
// provisioning tools.                                      
//                                                          
//==============================================================================
package org.plasma.sdo.profile;


import fUML.Syntax.Classes.Kernel.*;
import org.modeldriven.fuml.repository.ext.Stereotype;
import org.plasma.sdo.ValueSetConstraint;
/**
* 
* This stereotype allows a value set constraint to be specified for a class attribute. Attributes that have a coded type may be constrained such that the code value in an instance should be taken from the specified value set. The coding strength determines whether exceptions are allowed.
* 
* @author Plasma-Team
* @version 1.1.4
*/
public class SDOValueSetConstraint extends Stereotype
    implements ValueSetConstraint
{

    public static final String BASE__PROPERTY = "base_Property";
    /**
    * The globally unique identifier for the value set
    */
    public static final String ID = "id";
    /**
    * The descriptive name associated with the value set
    */
    public static final String NAME = "name";
    /**
    * The value which identifies a specific version of the value set. Used when performing static references to a value set
    */
    public static final String VERSION_IDENTIFIER = "versionIdentifier";
    /**
    * The date on which a specific version of the value set was created. Used when performing static references to a value set
    */
    public static final String VERSION_DATE = "versionDate";
    /**
    * The time when a specific version of the value set was created. Used when performing static references to a value set
    */
    public static final String VERSION_TIME = "versionTime";
    /**
    * Indicates whether or not codes are restricted to those expressed in the value set
    */
    public static final String CODING_STRENGTH = "codingStrength";
    /**
    * Defines the set of codes within the overall value set that must be supported by an implementer to be considered compliant
    */
    public static final String MINIMUM_VALUE_SET_ID = "minimumValueSetId";
    /**
    * Defines the set of codes within the overall value set that the implementer is willing to accept without raising an error, but whose content will be ignored and not processed in any useful manner
    */
    public static final String IGNORED_VALUE_SET_ID = "ignoredValueSetId";
    /**
    * Allows conveying the root code of the value set. Only usable for key structural attributes.
    */
    public static final String ROOT_CODE = "rootCode";

    private Property base_Property;
    /**
    * The globally unique identifier for the value set
    */
    private String id;
    /**
    * The descriptive name associated with the value set
    */
    private String name;
    /**
    * The value which identifies a specific version of the value set. Used when performing static references to a value set
    */
    private String versionIdentifier;
    /**
    * The date on which a specific version of the value set was created. Used when performing static references to a value set
    */
    private String versionDate;
    /**
    * The time when a specific version of the value set was created. Used when performing static references to a value set
    */
    private String versionTime;
    /**
    * Indicates whether or not codes are restricted to those expressed in the value set
    */
    private CodingStrength codingStrength;
    /**
    * Defines the set of codes within the overall value set that must be supported by an implementer to be considered compliant
    */
    private String minimumValueSetId;
    /**
    * Defines the set of codes within the overall value set that the implementer is willing to accept without raising an error, but whose content will be ignored and not processed in any useful manner
    */
    private String ignoredValueSetId;
    /**
    * Allows conveying the root code of the value set. Only usable for key structural attributes.
    */
    private String rootCode;


    public Property getBase_Property() {
        return this.base_Property;
    }

    public void setBase_Property(Property value) {
        this.base_Property = value;
    }

    public String getId() {
        return this.id;
    }

    public void setId(String value) {
        this.id = value;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String value) {
        this.name = value;
    }

    public String getVersionIdentifier() {
        return this.versionIdentifier;
    }

    public void setVersionIdentifier(String value) {
        this.versionIdentifier = value;
    }

    public String getVersionDate() {
        return this.versionDate;
    }

    public void setVersionDate(String value) {
        this.versionDate = value;
    }

    public String getVersionTime() {
        return this.versionTime;
    }

    public void setVersionTime(String value) {
        this.versionTime = value;
    }

    public CodingStrength getCodingStrength() {
        return this.codingStrength;
    }

    public void setCodingStrength(CodingStrength value) {
        this.codingStrength = value;
    }

    public String getMinimumValueSetId() {
        return this.minimumValueSetId;
    }

    public void setMinimumValueSetId(String value) {
        this.minimumValueSetId = value;
    }

    public String getIgnoredValueSetId() {
        return this.ignoredValueSetId;
    }

    public void setIgnoredValueSetId(String value) {
        this.ignoredValueSetId = value;
    }

    public String getRootCode() {
        return this.rootCode;
    }

    public void setRootCode(String value) {
        this.rootCode = value;
    }
}
